Index: includes/definitions/mibs/cisco.inc.php
===================================================================
--- includes/definitions/mibs/cisco.inc.php	(revision 10265)
+++ includes/definitions/mibs/cisco.inc.php	(working copy)
@@ -1322,4 +1322,52 @@
 $config['mibs'][$mib]['mib_dir'] = 'cisco';
 $config['mibs'][$mib]['descr'] = '';
 
+// Cisco SD-WAN (formerly Viptela)
+
+$mib = 'VIPTELA-HARDWARE';
+$config['mibs'][$mib]['enable'] = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.41916.3';
+$config['mibs'][$mib]['mib_dir'] = 'cisco';
+$config['mibs'][$mib]['descr'] = '';
+$config['mibs'][$mib]['serial'][] = array('oid' => 'hardwareInventorySerialNumber.chassis.0');
+$config['mibs'][$mib]['hardware'][] = array('oid' => 'hardwareInventoryPartNumber.chassis.0');
+
+$mib = 'VIPTELA-OPER-BGP';
+$config['mibs'][$mib]['enable'] = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.41916.14';
+$config['mibs'][$mib]['mib_dir'] = 'cisco';
+$config['mibs'][$mib]['descr'] = '';
+
+$mib = 'VIPTELA-OPER-SYSTEM';
+$config['mibs'][$mib]['enable'] = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.41916.11';
+$config['mibs'][$mib]['mib_dir'] = 'cisco';
+$config['mibs'][$mib]['descr'] = '';
+$config['mibs'][$mib]['version'][] = array('oid' => 'systemStatusVersion.0');
+$config['mibs'][$mib]['processor']['systemStatusCpuIdle'] = array('type' => 'static', 'descr' => 'System CPU', 'oid' => 'systemStatusCpuIdle.0', 'idle' => TRUE);
+$config['mibs'][$mib]['mempool']['systemStatus'] = array('type'      => 'static', 'descr' => 'Memory', 'scale' => 1024,
+                                                                   'oid_total' => 'systemStatusMemTotal.0', 'oid_total_num' => '.1.3.6.1.4.1.41916.11.1.17.0',
+                                                                   'oid_free'  => 'systemStatusMemFree.0', 'oid_free_num' => '.1.3.6.1.4.1.41916.11.1.19.0',
+);
+
+$config['mibs'][$mib]['la'] = array(
+  'type'      => 'table', // In table mode get first entry
+  'filter'    => ['os' => 'viptela'], // Currently just simple hack, need common way
+  'scale'     => 1,
+  'oid_1min'  => 'systemStatusMin1Avg',  'oid_1min_num'  => '.1.3.6.1.4.1.41916.11.1.9.0',
+  'oid_5min'  => 'systemStatusMin5Avg',  'oid_5min_num'  => '.1.3.6.1.4.1.41916.11.1.10.0',
+  'oid_15min' => 'systemStatusMin15Avg', 'oid_15min_num' => '.1.3.6.1.4.1.41916.11.1.11.0',
+);
+
+$config['mibs'][$mib]['status'][] = array('oid'              => 'systemStatusState',
+                                          'descr'            => 'System Status',
+                                          'type'             => 'viptela-status-state',
+                                          'oid_num'          => '.1.3.6.1.4.1.41916.11.1.54');
+
+$type = 'viptela-status-state';
+$config['mibs'][$mib]['states'][$type][0] = array('name' => 'blkng-green', 'event' => 'ok');
+$config['mibs'][$mib]['states'][$type][1] = array('name' => 'green', 'event' => 'ok');
+$config['mibs'][$mib]['states'][$type][2] = array('name' => 'yellow', 'event' => 'warning');
+$config['mibs'][$mib]['states'][$type][3] = array('name' => 'red', 'event' => 'alert');
+
 // EOF
Index: includes/definitions/os/cisco.inc.php
===================================================================
--- includes/definitions/os/cisco.inc.php	(revision 10265)
+++ includes/definitions/os/cisco.inc.php	(working copy)
@@ -673,4 +673,18 @@
 $config['os'][$os]['graphs'][]              = "device_bits";
 */
 
+// Cisco SD-WAN (formerly Viptela)
+
+$os = "viptela";
+$config['os'][$os]['vendor']                = "Cisco";
+$config['os'][$os]['text']                  = "Cisco SD-WAN";
+$config['os'][$os]['type']                  = "network";
+$config['os'][$os]['sysObjectID'][]         = ".1.3.6.1.4.1.41916";
+$config['os'][$os]['mibs'][]                = "VIPTELA-HARDWARE";
+$config['os'][$os]['mibs'][]                = "VIPTELA-OPER-BGP";
+$config['os'][$os]['mibs'][]                = "VIPTELA-OPER-SYSTEM";
+$config['os'][$os]['graphs'][]              = "device_bits";
+$config['os'][$os]['graphs'][]              = "device_processor";
+$config['os'][$os]['graphs'][]              = "device_mempool";
+
 // EOF