Index: mibs/westermo/WESTERMO-LYNX-MIB
===================================================================
--- mibs/westermo/WESTERMO-LYNX-MIB	(revision 10320)
+++ mibs/westermo/WESTERMO-LYNX-MIB	(working copy)
@@ -352,16 +352,7 @@
     ::= { general 18 }
 
 portIndex OBJECT-TYPE
-    SYNTAX INTEGER {
-        port1(1),
-        port2(2),
-        port3(3),
-        port4(4),
-        port5(5),
-        port6(6),
-        port7(7),
-        port8(8)
-     }
+    SYNTAX INTEGER
      MAX-ACCESS read-only
      STATUS current
      DESCRIPTION
Index: includes/definitions/os/westermo.inc.php
===================================================================
--- includes/definitions/os/westermo.inc.php	(revision 10320)
+++ includes/definitions/os/westermo.inc.php	(working copy)
@@ -29,9 +29,9 @@
 // Westermo Wolverine, primary: v4.24.1, backup: v4.24.1, bootloader: v2017.12.0-1
 // Westermo Lynx, primary: v4.12.1, backup: v4.12.1, bootloader: v4.11
 // Westermo Falcon, primary: v4.19.1, backup: v4.11.0, bootloader: v4.07
-$config['os'][$os]['sysDescr_regex'][]      = '/Westermo (?<hardware>\w.+?), primary: v(?<version>\d\S+),/';
+$config['os'][$os]['sysDescr_regex'][]      = '/Westermo (?<features>\w.+?), primary: v(?<version>\d\S+),/';
 // Westermo Lynx
-$config['os'][$os]['sysDescr_regex'][]      = '/Westermo (?<hardware>\w[\w\- ]+)$/';
+$config['os'][$os]['sysDescr_regex'][]      = '/Westermo (?<features>\w[\w\- ]+)$/';
 $config['os'][$os]['vendortype_mib']        = 'WESTERMO-OID-MIB';
 //$config['os'][$os]['mibs'][]                = "WESTERMO-LYNX-MIB"; // Supported only for weos < 4 (use discovery)
 //$config['os'][$os]['mibs'][]                = "WESTERMO-WEOS-MIB"; // Supported only for weos >= 4 (use discovery)
Index: includes/definitions/mibs/westermo.inc.php
===================================================================
--- includes/definitions/mibs/westermo.inc.php	(revision 10320)
+++ includes/definitions/mibs/westermo.inc.php	(working copy)
@@ -36,7 +35,12 @@
   'descr'               => 'Chassis',
   'oid_num'             => '.1.3.6.1.4.1.16177.1.2.1.1',
   'scale'               => 1,
-  'min'                 => 0
+  'min'                 => 0,
+  'max'                 => 200,
+  'limit_low'           => 1,
+  'limit_low_warn'      => 5,
+  'limit_high_warn'     => 70,
+  'limit_high'          => 80
 ];
 
 // WESTERMO-LYNX-MIB::powerSupply.0 = INTEGER: okpowerAB(1)
@@ -49,17 +53,22 @@
 );
 
 $type = 'powerSupply';
-$config['mibs'][$mib]['states'][$type][1] = array('name' => 'okpowerAB',  'event' => 'ok');
-$config['mibs'][$mib]['states'][$type][2] = array('name' => 'okpowerA',   'event' => 'ok');
-$config['mibs'][$mib]['states'][$type][3] = array('name' => 'okpowerB',   'event' => 'warning');
+$config['mibs'][$mib]['states'][$type][0]  = array('name' => 'off',         'event' => 'ignore');
+$config['mibs'][$mib]['states'][$type][1]  = array('name' => 'okpowerAB',   'event' => 'ok');
+$config['mibs'][$mib]['states'][$type][2]  = array('name' => 'okpowerA',    'event' => 'ok'); //'alert' is correct but, it hard to disable if only one input is used.
+$config['mibs'][$mib]['states'][$type][3]  = array('name' => 'okpowerB',    'event' => 'ok');//'alert' is correct but, it hard to disable if only one input is used.




-// WESTERMO-LYNX-MIB::portDuplexMode.port1 = INTEGER: full(3)
+// WESTERMO-LYNX-MIB::portDuplexMode.1 = INTEGER: full(3)

 $config['mibs'][$mib]['ports']['ontTable']['oids'] = [
   /*'ifName'       => array('oid' => 'portSubdesc'),*/
-  'ifDuplex'       => array('oid' => 'portDuplexMode', 'transform' => [ 'action' => 'map', 'map' => [ 'full' => 'fullDuplex', 'half' => 'halfDuplex' ] ]),
+  'ifVlan'         => array('oid' => 'vlanId'),
+  'ifAdminStatus'  => array('oid' => 'portEnable', 'transform' => [ 'action' => 'map', 'map' => [ 'na' => 'unknown', 'enable'  => 'up', 'disable'   => 'down', ] ]),
+  'ifDuplex'       => array('oid' => 'portDuplexMode', 'transform' => [ 'action' => 'map', 'map' => [ 'full' => 'fullDuplex', 'half' => 'halfDuplex' ] ]),
   //'ifAlias'      => array('oid' => 'portName')
 ];
 
+
 $mib = 'WESTERMO-WEOS-MIB';
 $config['mibs'][$mib]['enable'] = 1;
 $config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.16177.2.1';