Index: includes/definitions/mibs/cisco.inc.php
===================================================================
--- includes/definitions/mibs/cisco.inc.php	(revision 10306)
+++ includes/definitions/mibs/cisco.inc.php	(working copy)
@@ -574,6 +574,76 @@
 $config['mibs'][$mib]['mib_dir'] = 'cisco';
 $config['mibs'][$mib]['descr'] = '';
 
+$mib = 'CISCO-VPC-MIB';
+$config['mibs'][$mib]['enable']       = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.9.9.807';
+$config['mibs'][$mib]['mib_dir']      = 'cisco';
+$config['mibs'][$mib]['descr']        = 'This MIB provides management information for vPC on Cisco devices.';
+
+$config['mibs'][$mib]['status'][] = array(
+  'oid'      => 'cVpcPeerKeepAliveStatus',
+  'descr'    => 'vPC Peer-Keepalive Status',
+  'measured' => 'device',
+  'type'     => 'vPCPKLStatus',
+  'oid_num'  => '.1.3.6.1.4.1.9.9.807.1.1.2.1.2');
+
+$config['mibs'][$mib]['status'][] = array(
+  'oid'      => 'cVpcPeerKeepAliveMsgSendStatus',
+  'descr'    => 'vPC Peer-Keepalive Send Status',
+  'measured' => 'device',
+  'type'     => 'vPCPKLSendStatus',
+  'oid_num'  => '.1.3.6.1.4.1.9.9.807.1.1.2.1.4');
+
+$config['mibs'][$mib]['status'][] = array(
+  'oid'      => 'cVpcPeerKeepAliveMsgRcvrStatus',
+  'descr'    => 'vPC Peer-Keepalive Receive Status',
+  'measured' => 'device',
+  'type'     => 'vPCPKLReceiveStatus',
+  'oid_num'  => '.1.3.6.1.4.1.9.9.807.1.1.2.1.7');
+
+$config['mibs'][$mib]['status'][] = array(
+  'oid'      => 'cVpcRoleStatus',
+  'descr'    => 'Operational vPC Role',
+  'measured' => 'device',
+  'type'     => 'vPCMode',
+  'oid_num'  => '.1.3.6.1.4.1.9.9.807.1.2.1.1.2');
+
+$config['mibs'][$mib]['status'][] = array(
+  'oid'      => 'cVpcDualActiveDetectionStatus',
+  'descr'    => 'vPC Dual Active Detected',
+  'measured' => 'device',
+  'type'     => 'vPCDualActiveStatus',
+  'oid_num'  => '.1.3.6.1.4.1.9.9.807.1.2.1.1.3');
+
+$type = 'vPCPKLStatus';
+$config['mibs'][$mib]['states'][$type][1] = array('name' => 'disabled',                         'event' => 'alert' );
+$config['mibs'][$mib]['states'][$type][2] = array('name' => 'alive',                            'event' => 'ok' );
+$config['mibs'][$mib]['states'][$type][3] = array('name' => 'peerUnreachable',                  'event' => 'alert' );
+$config['mibs'][$mib]['states'][$type][4] = array('name' => 'aliveButDomainIdDismatch',         'event' => 'alert' );
+$config['mibs'][$mib]['states'][$type][5] = array('name' => 'suspendedAsISSU',                  'event' => 'ok' );
+$config['mibs'][$mib]['states'][$type][6] = array('name' => 'suspendedAsDestIPUnreachable',     'event' => 'alert' );
+$config['mibs'][$mib]['states'][$type][7] = array('name' => 'suspendedAsVRFUnusable',           'event' => 'alert' );
+$config['mibs'][$mib]['states'][$type][8] = array('name' => 'misconfigured',                    'event' => 'alert' );
+
+$type = 'vPCPKLSendStatus';
+$config['mibs'][$mib]['states'][$type][1] = array('name' => 'success',                          'event' => 'ok' );
+$config['mibs'][$mib]['states'][$type][2] = array('name' => 'failure',                          'event' => 'alert' );
+
+$type = 'vPCPKLReceiveStatus';
+$config['mibs'][$mib]['states'][$type][1] = array('name' => 'success',                          'event' => 'ok' );
+$config['mibs'][$mib]['states'][$type][2] = array('name' => 'failure',                          'event' => 'alert' );
+
+$type = 'vPCMode';
+$config['mibs'][$mib]['states'][$type][1] = array('name' => 'primarySecondary',                 'event' => 'warning' );
+$config['mibs'][$mib]['states'][$type][2] = array('name' => 'primary',                          'event' => 'ok' );
+$config['mibs'][$mib]['states'][$type][3] = array('name' => 'secondaryPrimary',                 'event' => 'warning' );
+$config['mibs'][$mib]['states'][$type][4] = array('name' => 'secondary',                        'event' => 'ok' );
+$config['mibs'][$mib]['states'][$type][5] = array('name' => 'noneEstablished',                  'event' => 'alert' );
+
+$type = 'vPCDualActiveStatus';
+$config['mibs'][$mib]['states'][$type][1] = array('name' => 'true',                             'event' => 'alert' );
+$config['mibs'][$mib]['states'][$type][2] = array('name' => 'false',                            'event' => 'ok' );
+
 $mib = 'CISCO-VRF-MIB';
 $config['mibs'][$mib]['enable']       = 1;
 $config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.9.9.711';
Index: includes/definitions/os/cisco.inc.php
===================================================================
--- includes/definitions/os/cisco.inc.php	(revision 10306)
+++ includes/definitions/os/cisco.inc.php	(working copy)
@@ -239,6 +239,7 @@
 $config['os'][$os]['graphs'][]              = "device_processor";
 $config['os'][$os]['graphs'][]              = "device_mempool";
 $config['os'][$os]['sysDescr'][]            = "/Cisco NX\-OS/";
+$config['os'][$os]['mibs'][]                = "CISCO-VPC-MIB";
 
 $os = "sanos";
 $config['os'][$os]['text']                  = "Cisco SAN-OS";