Index: includes/definitions/mibs/tripplite.inc.php
===================================================================
--- includes/definitions/mibs/tripplite.inc.php	(revision 10377)
+++ includes/definitions/mibs/tripplite.inc.php	(working copy)
@@ -10,7 +10,7 @@
  *
  */
 
-
+// SNMPWEBCARD Family
 $mib                                  = 'TRIPPLITE-12X';
 $config['mibs'][$mib]['enable']       = 1;
 $config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.850.90';
@@ -38,4 +38,16 @@
 
 // Status = tlEnvHumidityInAlarm
 
+// WEBCARDLX Family
+$mib                                  = 'TRIPPLITE-PRODUCTS';
+$config['mibs'][$mib]['enable']       = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.850.1';
+$config['mibs'][$mib]['mib_dir']      = 'tripplite';
+$config['mibs'][$mib]['descr']        = '';
+$config['mibs'][$mib]['vendor'][]   = array('oid' => 'tlpDeviceManufacturer.0'); // TRIPPLITE-PRODUCTS::tlpDeviceManufacturer.0 = STRING: "TRIPPLITE"
+$config['mibs'][$mib]['hardware'][] = array('oid' => 'tlpDeviceModel.0'); // TRIPPLITE-PRODUCTS::tlpDeviceModel.0 = STRING: "SU8000RT3UPM"
+$config['mibs'][$mib]['version'][]  = array('oid' => 'tlpAgentVersion.0'); // TRIPPLITE-PRODUCTS::tlpAgentVersion.0 = STRING: "15.5.3 (Build 1031)"
+$config['mibs'][$mib]['serial'][]   = array('oid' => 'tlpAgentSerialNum.0'); // TRIPPLITE-PRODUCTS::tlpAgentSerialNum.0 = STRING: "2825XX0XX88X200434"
+
+
 // EOF
Index: includes/definitions/mibs/ubiquiti.inc.php
===================================================================
--- includes/definitions/mibs/ubiquiti.inc.php	(revision 10377)
+++ includes/definitions/mibs/ubiquiti.inc.php	(working copy)
@@ -162,9 +162,9 @@
 $config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.41112.1.2.5';
 $config['mibs'][$mib]['mib_dir'] = 'ubiquiti';
 $config['mibs'][$mib]['descr'] = '';
-$config['mibs'][$mib]['hardware'][]  = array('oid' => 'unifiApSystemModel', 'transformations' => array('action' => 'regex_replace', 'from' => '/^UAP/', 'to' => 'UniFi AP')); // UBNT-UniFi-MIB::unifiApSystemModel = STRING: UAP-AC-LR
-$config['mibs'][$mib]['version'][]   = array('oid' => 'unifiApSystemVersion'); // UBNT-UniFi-MIB::unifiApSystemVersion = STRING: 3.7.29.5446
-$config['mibs'][$mib]['uptime'][]    = array('oid' => 'unifiApSystemUptime');  // UBNT-UniFi-MIB::unifiApSystemUptime = Counter32: 23814187
+$config['mibs'][$mib]['hardware'][]  = array('oid' => 'unifiApSystemModel.0', 'transformations' => array('action' => 'regex_replace', 'from' => '/^UAP/', 'to' => 'UniFi AP')); // UBNT-UniFi-MIB::unifiApSystemModel.0 = STRING: UAP-AC-LR
+$config['mibs'][$mib]['version'][]   = array('oid' => 'unifiApSystemVersion.0'); // UBNT-UniFi-MIB::unifiApSystemVersion.0 = STRING: 3.7.29.5446
+$config['mibs'][$mib]['uptime'][]    = array('oid' => 'unifiApSystemUptime.0');  // UBNT-UniFi-MIB::unifiApSystemUptime.0 = Counter32: 23814187
 
 $mib = 'UBNT-EdgeMAX-MIB';
 $config['mibs'][$mib]['enable'] = 1;
Index: includes/polling/os/vmware.inc.php
===================================================================
--- includes/polling/os/vmware.inc.php	(revision 10377)
+++ includes/polling/os/vmware.inc.php	(working copy)
@@ -23,10 +23,23 @@
  *  features:  build-348481
  */
 
-$data     = snmp_get_multi_oid($device, 'vmwProdName.0 vmwProdVersion.0 vmwProdBuild.0 vmwProdUpdate.0', array(), 'VMWARE-SYSTEM-MIB');
-$update   = ($data[0]['vmwProdUpdate'] ? ' U' . $data[0]['vmwProdUpdate'] : ''); // Only add update info if update > 0
-$version  = preg_replace('/^VMware /', '', $data[0]['vmwProdName']) . ' ' . $data[0]['vmwProdVersion'] . $update;
-$features = 'build-' . $data[0]['vmwProdBuild'];
+if (str_icontains($poll_device['sysDescr'], ['VMware vCenter Server Appliance', 'VMware-vCenter-Server-Appliance'])) // Use old method when VCSA detected, does not handle multiple oid request
+{
+	$vmwProdName    = snmp_get_oid($device, 'vmwProdName.0', 'VMWARE-SYSTEM-MIB');
+	$vmwProdVersion = snmp_get_oid($device, 'vmwProdVersion.0', 'VMWARE-SYSTEM-MIB');
+	$vmwProdBuild 	= snmp_get_oid($device, 'vmwProdBuild.0', 'VMWARE-SYSTEM-MIB');
+	$vmwProdUpdate  = snmp_get_oid($device, 'vmwProdUpdate.0', 'VMWARE-SYSTEM-MIB');
+	$update         = ($vmwProdUpdate ? ' U' . $vmwProdUpdate : ''); // Only add update info if update > 0
+	$version        = preg_replace('/^VMware /', '', $vmwProdName) . ' ' . $vmwProdVersion . $update;
+	$features       = 'build-' . $vmwProdBuild;
+}
+else
+{
+	$data     = snmp_get_multi_oid($device, 'vmwProdName.0 vmwProdVersion.0 vmwProdBuild.0 vmwProdUpdate.0', array(), 'VMWARE-SYSTEM-MIB');
+	$update   = ($data[0]['vmwProdUpdate'] ? ' U' . $data[0]['vmwProdUpdate'] : ''); // Only add update info if update > 0
+	$version  = preg_replace('/^VMware /', '', $data[0]['vmwProdName']) . ' ' . $data[0]['vmwProdVersion'] . $update;
+	$features = 'build-' . $data[0]['vmwProdBuild'];
+}
 
 if (is_array($entPhysical))
 {