Index: mibs/ekinops.inc.php
===================================================================
--- mibs/ekinops.inc.php	(revision 10272)
+++ mibs/ekinops.inc.php	(working copy)
@@ -68,7 +68,6 @@
                                               // if value >=32768 Tx_Pwr(dBm) = (value-65536)/100
                                               'unit'           => 'ekinops_dbm1');
 
-/*
 $config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
                                               //'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%pm10010mpCfgLabellinePortn%' ] ],
                                               //'table'          => 'pm10010mpCntlocalLineTrscvFecCorrectedErrorCounterTable',
@@ -86,7 +85,6 @@
                                               'descr'          => 'FEC UNCorrected errors (%oid_descr%)',
                                               'class'          => 'counter',
                                               'oid_num'        => '1.3.6.1.4.1.20044.58.4.3.197.1.2');
-*/
 
 $config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
                                               'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%pm10010mpCfgLabelclientPortn%' ] ],
@@ -123,7 +121,110 @@
                                               'oid_descr'      => 'pm10010mpCfgLabelclientPortn', // from pm10010mpCfgLabelclientTable
                                               'descr'          => 'Client Trscv Rx Power (%oid_descr%)',
                                               'class'          => 'dbm',
-                                              'oid_num'        => '1.3.6.1.4.1.20044.58.3.2.48.1.2',
+                                              'oid_num'        => '.1.3.6.1.4.1.20044.58.3.2.64.1.2',
                                               'unit'           => 'ekinops_dbm2'); // Power = 10*log(AV)-40) (Unit = dBm)
 
+$mib = 'EKINOPS-Rm10010-MIB';
+$config['mibs'][$mib]['enable'] = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.20044.53';
+$config['mibs'][$mib]['descr'] = '';
+$config['mibs'][$mib]['mib_dir'] = 'ekinops';
+
+$config['mibs'][$mib]['sensor'][]     = array('oid'            => 'rm10010MesrlineMsaTemp',
+                                              'descr'          => 'Line Trscv Temperature',
+                                              'class'          => 'temperature',
+                                              'oid_num'        => '.1.3.6.1.4.1.20044.53.3.3.12',
+                                              'scale'          => 0.00390625); // value/256
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabellinePortn%' ] ],
+                                              //'table'          => 'rm10010MesrlineNetTxLaserOutputPwrTable',
+                                              'oid'            => 'rm10010MesrlineNetTxLaserOutputPwrPortn',
+                                              'class'          => 'dbm',
+                                              'oid_num'        => '.1.3.6.1.4.1.20044.53.3.3.80.1.2',
+                                              'oid_descr'      => 'rm10010CfgLabellinePortn', // from rm10010CfgLabellineTable
+                                              'descr'          => 'Line Trscv Tx Power (%oid_descr%)',
+                                              // if value < 32768 Tx_Pwr(dBm) = value/100
+                                              // if value >=32768 Tx_Pwr(dBm) = (value-65536)/100
+                                              'unit'           => 'ekinops_dbm1');
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabellinePortn%' ] ],
+                                              //'table'          => 'rm10010MesrlineNetTxLaserTempTable',
+                                              'oid'            => 'rm10010MesrlineNetTxLaserTempPortn',
+                                              'class'          => 'temperature',
+                                              'oid_num'        => '1.3.6.1.4.1.20044.53.3.3.96.1.2',
+                                              'oid_descr'      => 'rm10010CfgLabellinePortn', // from rm10010CfgLabellineTable
+                                              'descr'          => 'Line Trscv Tx Laser Temperature (%oid_descr%)',
+                                              'scale'          => 0.00390625); // value/256
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabellinePortn%' ] ],
+                                              //'table'          => 'rm10010MesrlineNetRxInputPwrTable',
+                                              'oid'            => 'rm10010MesrlineNetRxInputPwrPortn',
+                                              'class'          => 'dbm',
+                                              'oid_num'        => '.1.3.6.1.4.1.20044.53.3.3.128.1.2',
+                                              'oid_descr'      => 'rm10010CfgLabellinePortn', // from rm10010CfgLabellineTable
+                                              'descr'          => 'Line Trscv Rx Power (%oid_descr%)',
+                                              // if value < 32768 Tx_Pwr(dBm) = value/100
+                                              // if value >=32768 Tx_Pwr(dBm) = (value-65536)/100
+                                              'unit'           => 'ekinops_dbm1');
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              //'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabellinePortn%' ] ],
+                                              //'table'          => 'rm10010CntlocalLineTrscvFecCorrectedErrorCounterTable',
+                                              'oid'            => 'rm10010CntlocalLineTrscvFecCorrectedErrorCounterValuePortn',
+                                              'oid_descr'      => 'rm10010CfgLabellinePortn', // from rm10010CfgLabellineTable
+                                              'descr'          => 'FEC Corrected errors (%oid_descr%)',
+                                              'class'          => 'counter',
+                                              'oid_num'        => '1.3.6.1.4.1.20044.53.4.3.196.1.2');
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              //'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabellinePortn%' ] ],
+                                              //'table'          => 'rm10010CntlocalLineTrscvFecUncorrectedErrorCounterTable',
+                                              'oid'            => 'rm10010CntlocalLineTrscvFecUncorrectedErrorCounterValuePortn',
+                                              'oid_descr'      => 'rm10010CfgLabellinePortn', // from rm10010CfgLabellineTable
+                                              'descr'          => 'FEC UNCorrected errors (%oid_descr%)',
+                                              'class'          => 'counter',
+                                              'oid_num'        => '1.3.6.1.4.1.20044.53.4.3.197.1.2');
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabelclientPortn%' ] ],
+                                              //'table'          => 'rm10010MesrclientNetTxTempTable',
+                                              'class'          => 'temperature',
+                                              'oid'            => 'rm10010MesrclientNetTxTempPortn',
+                                              'oid_descr'      => 'rm10010CfgLabelclientPortn', // from rm10010CfgLabelclientTable
+                                              'descr'          => 'Client Trscv Temperature (%oid_descr%)',
+                                              'scale'          => 0.00390625); // value/256
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabelclientPortn%' ] ],
+                                              //'table'          => 'rm10010MesrclientNetTxBiasTable',
+                                              'class'          => 'current',
+                                              'oid'            => 'rm10010MesrclientNetTxBiasPortn',
+                                              'oid_descr'      => 'rm10010CfgLabelclientPortn', // from rm10010CfgLabelclientTable
+                                              'descr'          => 'Client Trscv Laser Bias (%oid_descr%)',
+                                              'scale'          => 0.002); // value/500
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabelclientPortn%' ] ],
+                                              //'table'          => 'rm10010MesrclientNetTxPwrTable',
+                                              'oid'            => 'rm10010MesrclientNetTxPwrPortn',
+                                              'oid_descr'      => 'rm10010CfgLabelclientPortn', // from rm10010CfgLabelclientTable
+                                              'descr'          => 'Client Trscv Tx Power (%oid_descr%)',
+                                              'class'          => 'dbm',
+                                              'oid_num'        => '1.3.6.1.4.1.20044.53.3.2.48.1.2',
+                                              'unit'           => 'ekinops_dbm2'); // Power = 10*log(AV)-40) (Unit = dBm)
+
+$config['mibs'][$mib]['sensor'][]     = array('measured'       => 'port',
+                                              'measured_match' => [ ['entity_type' => 'port', 'field' => 'ifAlias', 'match' => '%rm10010CfgLabelclientPortn%' ] ],
+                                              //'table'          => 'rm10010MesrclientNetRxPwrTable',
+                                              'oid'            => 'rm10010MesrclientNetRxPwrPortn',
+                                              'oid_descr'      => 'rm10010CfgLabelclientPortn', // from rm10010CfgLabelclientTable
+                                              'descr'          => 'Client Trscv Rx Power (%oid_descr%)',
+                                              'class'          => 'dbm',
+                                              'oid_num'        => '.1.3.6.1.4.1.20044.53.3.2.64.1.2',
+                                              'unit'           => 'ekinops_dbm2'); // Power = 10*log(AV)-40) (Unit = dBm)
+
+
 // EOF
Index: os.inc.php
===================================================================
--- os.inc.php	(revision 10272)
+++ os.inc.php	(working copy)
@@ -1288,7 +1310,7 @@
 $os = "ekinops-360";
 $config['os'][$os]['text']                  = "Ekinops 360";
 $config['os'][$os]['vendor']                = "Ekinops";
-$config['os'][$os]['type']                  = "network";
+$config['os'][$os]['type']                  = "optical";
 $config['os'][$os]['sysObjectID'][]         = ".1.3.6.1.4.1.20044";
 //Ekinops 360 Platform, C200, Release 3.1.542
 //Ekinops 360 Platform, C200HC, Release 4.5.710
@@ -1299,6 +1321,7 @@
 $config['os'][$os]['remote_access']         = array('ssh', 'http');
 $config['os'][$os]['mibs'][]                = "EKINOPS-MGNT2-MIB";
 $config['os'][$os]['mibs'][]                = "EKINOPS-Pm10010mp-MIB";
+$config['os'][$os]['mibs'][]                = "EKINOPS-Rm10010-MIB";
 
 // Eltex
 