Index: includes/definitions/mibs/d-link.inc.php
===================================================================
--- includes/definitions/mibs/d-link.inc.php	(revision 11377)
+++ includes/definitions/mibs/d-link.inc.php	(working copy)
@@ -244,6 +244,24 @@
 $config['mibs'][$mib]['mib_dir'] = 'd-link';
 $config['mibs'][$mib]['descr'] = 'D-Link DGS3627G L2MGMT MIB';
 
+$mib = 'DGS-3620-28SC-L2MGMT-MIB';
+$config['mibs'][$mib]['enable'] = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.171.11.118.2.2';
+$config['mibs'][$mib]['mib_dir'] = 'd-link';
+$config['mibs'][$mib]['descr'] = '';
+
+$mib = 'DGS-3420-28SC-L2MGMT-MIB';
+$config['mibs'][$mib]['enable'] = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.171.11.119.2.2';
+$config['mibs'][$mib]['mib_dir'] = 'd-link';
+$config['mibs'][$mib]['descr'] = '';
+
+$mib = 'DGS-3420-26SC-L2MGMT-MIB';
+$config['mibs'][$mib]['enable'] = 1;
+$config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.171.11.119.6.2';
+$config['mibs'][$mib]['mib_dir'] = 'd-link';
+$config['mibs'][$mib]['descr'] = '';
+
 $mib = 'DES-1228-MIB';
 $config['mibs'][$mib]['enable'] = 1;
 $config['mibs'][$mib]['identity_num'] = '.1.3.6.1.4.1.171.10.75.2';
Index: includes/discovery/inventory/entity-mib.inc.php
===================================================================
--- includes/discovery/inventory/entity-mib.inc.php	(revision 11377)
+++ includes/discovery/inventory/entity-mib.inc.php	(working copy)
@@ -51,6 +51,26 @@
   $vendor_oids = snmpwalk_cache_oid($device, "swL2PortSfpInfoTable", $vendor_oids, $vendor_mib, NULL, $snmp_flags);
   //print_vars($entity_array);
   //print_debug_vars($vendor_oids);
+  } elseif (is_device_mib($device, 'DGS-3420-28SC-L2MGMT-MIB')) {
+    $vendor_mib = 'DGS-3420-28SC-L2MGMT-MIB';
+    $vendor_oids = snmpwalk_cache_oid($device, "swL2PortSfpInfoTable", $vendor_oids, $vendor_mib, NULL, $snmp_flags);
+    //print_vars($entity_array);
+    //print_debug_vars($vendor_oids);
+  } elseif (is_device_mib($device, 'DGS-3420-26SC-L2MGMT-MIB')) {
+    $vendor_mib = 'DGS-3420-26SC-L2MGMT-MIB';
+    $vendor_oids = snmpwalk_cache_oid($device, "swL2PortSfpInfoTable", $vendor_oids, $vendor_mib, NULL, $snmp_flags);
+    //print_vars($entity_array);
+    //print_debug_vars($vendor_oids);
+  } elseif (is_device_mib($device, 'DGS-3620-28SC-L2MGMT-MIB')) {
+    $vendor_mib = 'DGS-3620-28SC-L2MGMT-MIB';
+    $vendor_oids = snmpwalk_cache_oid($device, "swL2PortSfpInfoTable", $vendor_oids, $vendor_mib, NULL, $snmp_flags);
+    //print_vars($entity_array);
+    //print_debug_vars($vendor_oids);
+  } elseif (is_device_mib($device, 'DGS-3620-26SC-L2MGMT-MIB')) {
+    $vendor_mib = 'DGS-3620-26SC-L2MGMT-MIB';
+    $vendor_oids = snmpwalk_cache_oid($device, "swL2PortSfpInfoTable", $vendor_oids, $vendor_mib, NULL, $snmp_flags);
+    //print_vars($entity_array);
+    //print_debug_vars($vendor_oids);
 }
 
 foreach ($entity_array as $entPhysicalIndex => $entry) {
Index: includes/definitions/os/d-link.inc.php
===================================================================
--- includes/definitions/os/d-link.inc.php	(revision 11377)
+++ includes/definitions/os/d-link.inc.php	(working copy)
@@ -254,10 +254,10 @@
   '.1.3.6.1.4.1.171.10.117.6.1' => array('name' => 'DGS-3120-48PC-BX'),
   '.1.3.6.1.4.1.171.10.117.7.1' => array('name' => 'DGS-3120-24SC-DC-BX'),
   '.1.3.6.1.4.1.171.10.118.1'   => array('name' => 'DGS-3620-28TC'),
-  '.1.3.6.1.4.1.171.10.118.2'   => array('name' => 'DGS-3620-28SC'),
+  '.1.3.6.1.4.1.171.10.118.2'   => array('name' => 'DGS-3620-28SC',       'mibs' => array('DGS-3620-28SC-L2MGMT-MIB')),
   '.1.3.6.1.4.1.171.10.119.1'   => array('name' => 'DGS-3420-28TC'),
-  '.1.3.6.1.4.1.171.10.119.2'   => array('name' => 'DGS-3420-28SC'),
-  '.1.3.6.1.4.1.171.10.119.6'   => array('name' => 'DGS-3420-26SC'),
+  '.1.3.6.1.4.1.171.10.119.2'   => array('name' => 'DGS-3420-28SC',       'mibs' => array('DGS-3420-28SC-L2MGMT-MIB')),
+  '.1.3.6.1.4.1.171.10.119.6'   => array('name' => 'DGS-3420-26SC',       'mibs' => array('DGS-3420-26SC-L2MGMT-MIB')),
   '.1.3.6.1.4.1.171.10.126.1'   => array('name' => 'DGS-1500-20'),
   '.1.3.6.1.4.1.171.10.126.2.1' => array('name' => 'DGS-1500-28'),
   '.1.3.6.1.4.1.171.10.127.1'   => array('name' => 'DXS-3600-32S'),